package application.app.controller
{

	import application.app.view.ViewGagne;
	import application.app.model.RPGProxySound;
	import application.app.ApplicationFacade;
	
	import application.app.view.ViewHeros;
	import application.app.model.RPGProxy;
	import application.app.view.ViewGameOver;
	
	import org.puremvc.as3.interfaces.ICommand;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;

	
	/**
	 * Commande qui exécute d'autres sous-commandes
	 * 
	 * 
	 * @author matth
	 */
	public class GameOverCommand extends SimpleCommand implements ICommand
    {
 		
 		/**
 		 * Evènement ApplicationFacade.COMMAND_LOAD_MENU reçu.
 		 * Excécution du code souhaité - chargement des données du model.
 		 * 
 		 */
        override public function execute(notification:INotification):void
        {
			var sAction:String = notification.getBody() as String;
			
			var oProxy:RPGProxy = facade.retrieveProxy(RPGProxy.NAME) as RPGProxy;
			var oViewHeros:ViewHeros = facade.retrieveMediator(ViewHeros.NAME) as ViewHeros;
			
			oViewHeros.stopControls();
			oProxy.stopFrame();	
			
			if( sAction == RPGProxy.RESTART_LEVEL)
				sendNotification(ApplicationFacade.COMMAND_HEROS_ACTION_SOUND, RPGProxySound.PLAYER_DEAD );
				
			else if( sAction == RPGProxy.END_LEVEL)
			{
				sendNotification(ApplicationFacade.UPDATE_HEROS_SCORE, 63);
				sendNotification(ApplicationFacade.COMMAND_HEROS_ACTION_SOUND, RPGProxySound.PLAYER_WIN );
				var oViewGagne:ViewGagne = facade.retrieveMediator(ViewGagne.NAME) as ViewGagne; 
				oViewGagne.seeView();	
			}
			else
			{
				sendNotification(ApplicationFacade.COMMAND_HEROS_ACTION_SOUND, RPGProxySound.PLAYER_GAME_OVER );
				var oViewGameOver:ViewGameOver = facade.retrieveMediator(ViewGameOver.NAME) as ViewGameOver; 
				oViewGameOver.seeView();	
			}
        }
 
    }


}
