package application.app.view
{
	import application.app.ApplicationFacade;
	import flash.display.Sprite;

	import org.puremvc.as3.interfaces.IMediator;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.mediator.Mediator;


	
	/**
	 * Permet de construire notre menu et d'interagir avec nos composants graphiques.
	 * 
	 * @author matth
	 */
	public class ViewBackground extends Mediator implements IMediator
    {
		public static const NAME : String = "ViewBackground";
		
		private var oNuage1 : Sprite;
		private var oNuage2 : Sprite;
		
        
        public function ViewBackground(viewComponent:Object)
        {
        	super(NAME, viewComponent);
        	
  			setupUi();
		}

		/**
		 * Initialisation de l'interface utilisateur.
		 * 
		 */
		private function setupUi() : void
		{
			oNuage1 = new Background();
			oNuage2 = new Background();
			
			oNuage1.y = oNuage2.y = 20;// place du score en haut
			oNuage1.x = (oNuage1.width / 2) - oNuage1.width;
			oNuage2.x = oNuage1.x + oNuage1.width-1;
			
			stageV.addChild(oNuage1);
			stageV.addChild(oNuage2);
		}


		/**
		 * Déplacement des nuages dans un sens ou l'autre lorsque le héros bouge.
		 * @param nDir : direction du déplacement : gauche ou droite.
		 */
 		private function moveBackground(nDirection:int) : void
		{
			if( nDirection == 1 )// déplacement vers la droite
			{
				oNuage1.x--;
				oNuage2.x--;
				
				// si le nuage est sorti de l'écran, fin du défilement
				// on le remet à côté du 2ème
				if( oNuage1.x < -oNuage1.width )
					oNuage1.x = oNuage2.x + oNuage2.width-1;
				
				// idem pour le nuage 2	
				if( oNuage2.x < -oNuage2.width )
					oNuage2.x = oNuage1.x + oNuage1.width-1;
			}
			else if ( nDirection == -1 )// déplacement vers la gauche
			{
				oNuage1.x++;
				oNuage2.x++;
				
				// si le nuage est sorti de l'écran, fin du défilement
				// on le remet à côté du 2ème
				if( oNuage1.x > oNuage1.width )
					oNuage1.x = oNuage2.x - oNuage2.width+1;
					
				if( oNuage2.x > oNuage2.width )
					oNuage2.x = oNuage1.x - oNuage1.width+1;	
			}
		}
		
		
		
 		/**
 		 * Transtypage du viewComponent en son type actuel.
 		 * 
 		 */
        protected function get stageV():Sprite
        {
            return viewComponent as Sprite;
        }
 		
 		
 		/**
 		 * Notifications attendues.
 		 * 
 		 */
        override public function listNotificationInterests():Array
        {
			return [
					ApplicationFacade.MOVE_BACKGROUND
				   ];
        }
 		
 		
 		/**
 		 * Gestion des notifications.
 		 * 
 		 */
        override public function handleNotification(note:INotification):void
        {
        	switch (note.getName())
			{
				case ApplicationFacade.MOVE_BACKGROUND:
					this.moveBackground( int(note.getBody()) );					
					break;
			}
		}

		
	 
    }

}
