package application.app.view
{
	import flash.events.TextEvent;
	import application.app.ApplicationFacade;
	import com.actionscriptfacile.ui.text.UITextField;
	import flash.display.Sprite;

	
	import org.puremvc.as3.interfaces.IMediator;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.mediator.Mediator;

	/**
	 * Permet de construire notre menu et d'interagir avec nos composants graphiques.
	 * 
	 * @author matth
	 */
	public class ViewBorder extends Mediator implements IMediator
	{
		public static const NAME : String = "ViewBorder";
		
		private var oTxtScore : UITextField;	
		private var oTxtLife : UITextField;	
		private var oTxtProgressLoad : UITextField;
		
		private var bSoundOn : Boolean;
		
		
		
		public function ViewBorder (viewComponent : Object)
		{
			super(NAME, viewComponent);

			setupUi();
		}


		/**
		 * Initialisation de l'interface utilisateur.
		 * 
		 */
		private function setupUi() : void
		{
			var oBordure:Sprite = new Border();
			stageV.addChild(oBordure);
			
			oTxtLife = new UITextField();
			oTxtLife.x = 34;
			oTxtLife.y = 8;
			oTxtLife.text = "Vie : --";
			oTxtLife.selectable = false;
			oTxtLife.autoSizeLeft();
			oTxtLife.alignCenter(); // centre le texte
			oTxtLife.changeFormat("size", 11);// changement de la taille de la police du texte
			oTxtLife.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtLife.changeFormat("bold", true);// changement de la taille de la police du texte
			oTxtLife.changeFormat("color", 0X00C5DF);// changement de la couleur
			stageV.addChild(oTxtLife);
			
			
			oTxtScore = new UITextField();
			oTxtScore.x = oTxtLife.x + 69;
			oTxtScore.y = oTxtLife.y;
			oTxtScore.text = "Score : --";
			oTxtScore.selectable = false;
			oTxtScore.autoSizeLeft();
			oTxtScore.alignCenter(); // centre le texte
			oTxtScore.changeFormat("size", 11);// changement de la taille de la police du texte
			oTxtScore.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtScore.changeFormat("bold", true);// changement de la taille de la police du texte
			oTxtScore.changeFormat("color", 0X00C5DF);// changement de la couleur
			stageV.addChild(oTxtScore);
			
			
			bSoundOn = true;
			oTxtProgressLoad = new UITextField();
			oTxtProgressLoad.x = oTxtScore.x + 102;
			oTxtProgressLoad.y = oTxtLife.y;
			oTxtProgressLoad.htmlText = "Chargement : --";
			oTxtProgressLoad.selectable = false;
			oTxtProgressLoad.autoSizeLeft();
			oTxtProgressLoad.alignCenter(); // centre le texte
			oTxtProgressLoad.changeFormat("size", 11);// changement de la taille de la police du texte
			oTxtProgressLoad.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtProgressLoad.changeFormat("bold", true);// changement de la taille de la police du texte
			oTxtProgressLoad.changeFormat("color", 0X00C5DF);// changement de la couleur
			oTxtProgressLoad.addEventListener( TextEvent.LINK, onSoundClicked );
			stageV.addChild(oTxtProgressLoad);
		}
		
		private function onSoundClicked ( pEvt:TextEvent ):void
		{
			bSoundOn = !bSoundOn;// mise à jour de la variable son
			sendNotification(ApplicationFacade.COMMAND_SOUND_ON_OFF, bSoundOn);
		}
		
		
		/**
		 * Mets à jour le texte score du Héros.
		 * 
		 */
		private function updateTxtScore(sValue:String) : void
		{
			oTxtScore.text = "Score : "+sValue;
		}


		/**
		 * Mets à jour le texte score du Héros.
		 * 
		 */
		private function updateTxtLife(sValue:String) : void
		{
			oTxtLife.text = "Vie : "+sValue;
		}
		
		/**
		 * Mets à jour le texte progression du chargement des éléments.
		 * 
		 */
		private function updateTxtLoadProgress(sValue:String) : void
		{
			oTxtProgressLoad.htmlText = sValue;
		}
		
		/**
		 * Transtypage du viewComponent en son type actuel.
		 * 
		 */
		protected function get stageV() : Sprite
		{
			return viewComponent as Sprite;
		}

		/**
		 * Notifications attendues.
		 * 
		 */
		override public function listNotificationInterests() : Array
		{
			return [ ApplicationFacade.HEROS_SCORE,
					 ApplicationFacade.HEROS_LIFE,
					 ApplicationFacade.UPDATE_LOAD_PROGRESS
				   ];
		}

		/**
		 * Gestion des notifications.
		 * 
		 */
		override public function handleNotification(note : INotification) : void
		{
			var sValue:String = "";
			
			switch (note.getName())
			{
				case ApplicationFacade.HEROS_SCORE:// init du niveau de vie
					sValue = ( note.getBody() ).toString();
					this.updateTxtScore(sValue);
					break;
				
				case ApplicationFacade.HEROS_LIFE:// init du niveau de vie
					sValue = ( note.getBody() ).toString();
					this.updateTxtLife(sValue);
					break;
				
				case ApplicationFacade.UPDATE_LOAD_PROGRESS:// init du niveau de vie
					sValue = ( note.getBody() ).toString();
					this.updateTxtLoadProgress(sValue);
					break;	
			}
		}
	}
}
